# localizeMDSLqi.R

# cmdscale(d, k = 2, eig = FALSE, add = FALSE, x.ret = FALSE)
# as.dist(m, diag = FALSE, upper = FALSE)
# dissimMatrix <- matrix with lower triangle = dissimilarities

ji <- inp1$lqi > 128
inp1$lqi[ji] = 383 - inp1$lqi[ji]
inp1$lqi[!ji] = 128 - inp1$lqi[!ji]

mat <- array(0, dim=c(19,19))
matb <- array(0, dim=c(19,19))
mat2 <- array(0, dim=c(19,19))

diag(mat) <- 0

lqis <- numeric()

len = 10000 #length(inp1$src)

for (i in 2:19) {
  for (j in (i+1):20) {
      x <- 0
      for (k in 1:len) {
        if ((inp1$src[k] == i && inp1$pongsrc[k] == j) || ( inp1$src[k] == j && inp1$pongsrc[k] == i)) {
          lqis[x] <- inp1$lqi[k]
          x<-x+1
        }
      }
#        print(lqis)
      #mat[j-1,i-1] <- (-10.50084 + (mean(lqis) * 0.09973)) #to get dissimilarities
      mat[j-1,i-1] <- mean(lqis)
      #mat[i-1,j-1] <- mat[j-1,i-1]
      #matb[j-1,i-1] <- (-11.04994 + (mean(lqis) * 0.10467)) #to get dissimilarities
      #matb[i-1,j-1] <- matb[j-1,i-1]

      #mat2[i-1,j-1] <- distance(i,j)
      #mat2[j-1,i-1] <- mat2[i-1,j-1]
  }


}

#  error <- sqrt((mat2 - mat)^2)
#  print("lqi based estimated distance")
#  print(mat)
#  print("oracle distance")
#  print(mat2)
#  print("error")
#  print(error)
#  print("erreur moyenne")
#  print(mean(error))
#  print("erreur var")
#  print(var(error))


real.x <- numeric()
real.y <- numeric()
real.x[1] <- 0
real.y[1] <- 0
real.x[2] <- 0
real.y[2] <- 1
real.x[3] <- 0
real.y[3] <- 2
real.x[4] <- 0
real.y[4] <- 3

real.x[5] <- 1.5
real.y[5] <- 0
real.x[6] <- 1.5
real.y[6] <- 1
real.x[7] <- 1.5
real.y[7] <- 2
real.x[8] <- 1.5
real.y[8] <- 3

real.x[9] <- 3
real.y[9] <- 0
real.x[10] <- 3
real.y[10] <- 1
real.x[11] <- 3
real.y[11] <- 2
real.x[12] <- 3
real.y[12] <- 3

real.x[13] <- 4.5
real.y[13] <- 0
real.x[14] <- 4.5
real.y[14] <- 1
real.x[15] <- 4.5
real.y[15] <- 2
real.x[16] <- 4.5
real.y[16] <- 3

real.x[17] <- 6
real.y[17] <- 0
real.x[18] <- 6
real.y[18] <- 1
real.x[19] <- 6
real.y[19] <- 2

real.x <- real.x - mean(real.x)
real.y <- real.y - mean(real.y)

#  mds <- cmdscale(as.dist(mat))

mds <- cmdscale(as.dist(mat),add=TRUE,eig=TRUE,k=18)
print("Eigen values MDS LQI")
print(mds$eig)

x <- mds$points[,1]
y <- -mds$points[,2]
#x <- x - mean(x)
#y <- y - mean(y)


#  mdso <- cmdscale(mat2,add=TRUE,eig=TRUE,k=18)
#  print("Eigen values MDS ORACLE")
#  print(mdso$eig)

#  xo <- mdso$points[,1]
#  yo <- -mdso$points[,2]

#xo <- xo - mean(xo)
#yo <- yo - mean(yo)

#xiyi <- cbind(x,y)
#ximyi <- cbind(y,-x)

xy <- cbind(x,y)
xoyo <-cbind(real.x,real.y)

#totx <- rbind(xiyi,ximyi)

#toty <- rbind(t(t(xo)),t(t(yo)))

#rot <- lm(toty ~ totx - 1)

#browser()

#for (i in 1:19) {
#    x[i] = (x[i]*rot$coefficients[1])  + (y[i]*rot$coefficients[2])
#    y[i] = (-x[i]*rot$coefficients[2]) + (y[i]*rot$coefficients[1])
#}

good <- procrustes(xoyo, xy,scale = TRUE)

good2 <- procOPA(xoyo,xy)

mse <-  sqrt(good$ss/19)

plotab <- good$Yrot

#browser()
x11()
plot(good,main='MDS localisation with LQI',sub=paste('position MSE = ',mse))

x11()
plot(good2$Bhat,main='MDS localisation with LQI',sub=paste('position MSE = ',sqrt(good2$OSS/19)))
#plot (plotab,col="blue",main="localisatio MDS experience NO5",xlim=c(-3,3),ylim=c(-3,3)) #,
#text (plotab,labels=2:20,col="blue")


#points (xoyo,col="red")
#text (xoyo,labels=2:20,col="red")

browser()

#  str(mds)
#
#  svdm <- svd(mds$x)
#
#  str (svdm)
#
#  svdm$d <- sqrt(svdm$d)
#
#  eig <- eigen(svdm$u * svdm$d,TRUE )
#
#  str(eig)
#
#   x <- eig$values[1] * eig$vectors[1,]
#   y <- eig$values[2] * eig$vectors[2,]




#  print(mds)# contient les coordonnes des points
#
#  x <- mds$points[,1]
#  y <- -mds$points[,2]
#
# plot (x,y,col="blue") #,xlim=c(-3,3),ylim=c(-2,2)
# text (x,y,labels=2:20,col="blue")
#


#browser()



# 1 avoir la matrice P avec Pij = distance estime de i  j
# 2 B <- shift P to the center ??
# 3 calculer SVD(B) = VAV
# 4 matrice coordones X = V(A^1/2)
# retenir les 3 plus grande eigenvalues/eigenvectors de X  nous donne une solution

