# localizeMDSNO5.R
#inp1 <- scan("N2.txt", list(time=0,idx=0,seqno=0,src=0,pongsrc=0,lqi=0,rssi=0),dec = ",")

ji <- inp1$lqi > 128
inp1$lqi[ji] = 383 - inp1$lqi[ji]
inp1$lqi[!ji] = 128 - inp1$lqi[!ji]

mat <- array(0, dim=c(20,20))

lqis <- numeric()

len <- length(inp1$src)

for (i in 1:20) {
  for (j in (i+1):20) {
      x <- 0
      for (k in 1:len) {
        if ((inp1$src[k] == i && inp1$pongsrc[k] == j) || ( inp1$src[k] == j && inp1$pongsrc[k] == i)) {
          lqis[x] <- inp1$lqi[k]
          x<-x+1
        }
      }
#        print(lqis)
      mat[j-1,i-1] <- (-10.50084 + (mean(lqis) * 0.09973)) #to get dissimilarities
      mat[i-1,j-1] <- mat[j-1,i-1]
  }
}

mds <- cmdscale(mat,add=TRUE,eig=TRUE,k=18)

x <- mds$points[,1]
y <- -mds$points[,2]

plot (x,y,col="blue",pch=".",main="localisation MDS experience NO5") #,xlim=c(-3,3),ylim=c(-2,2)
text (x,y,labels=1:20,col="blue")
