#plotDistRssiLqi

oldwd = getwd()
setwd("C:\\Documents and Settings\\dwarfy\\My Documents\\MLG\\memoiremlg\\LOCALISATION\\EXPEBIBLIO")

rssi1 <-inp1$rssi
lqi1 <- inp1$lqi
fromid1 <- inp1$src
toid1 <- inp1$pongsrc


rssi2 <- inp2$rssi
lqi2 <- inp2$lqi
fromid2 <- inp2$src
toid2 <- inp2$pongsrc


setwd(oldwd)

lqi = c(lqi1,lqi2)
rssi = c(rssi1,rssi2)
fromid = c(fromid1,fromid2)
toid = c(toid1,toid2)


x <- 0
len <- length(fromid)
lqiX <- numeric()
rssiX <- numeric()
distX <- numeric()


startime <- 0.0

#times <- times / (3600 * 1024)

x <- 0

len <-1000

for (i in 1:len) {
	if (fromid[i] > 1 && toid[i] > 1) {
		lqiX[x] <- lqi[i]
		rssiX[x] <- rssi[i]
		distX[x] <- distance(fromid[i],toid[i])
		x<-x+1
	}

}

filename <- "distance-lqi-rssi.ps"
postscript(filename, family = "NimbusSan")

maintitle <- paste("Distance / LQI / RSSI")


subtitle <- paste("LQI mean :",mean(lqiX),"| LQI var :",var(lqiX),"| RSSI mean :",mean(rssiX),"| RSSI var :",var(rssiX),"| #mesures :",len,"| #nodes :19" )

layout(matrix(1:3, 3, 1),heights=c(1,1,2))


plot(density(lqiX),col = "dark red",xlim=c(260,220))
plot(density(rssiX),col = "dark blue",xlim=c(260,220))

plot(lqiX,distX,main=maintitle,sub=subtitle,ylab="Distance Between nodes",xlab="LQI value",pch=20, xlim=c(260,220) , col = "dark red")
points(rssiX,distX,col="dark blue",pch = 20)
legend(x = 260, y = 3, col = c("dark blue", "dark red"),pch = c(20,20), lty = 1,legend = c("RSSI", "LQI"))



dev.off()