#plotErrorsNode.R
inp1 <- scan("N1.txt", list(time=0,idx=0,seqno=0,src=0,pongsrc=0,lqi=0,rssi=0),dec = ",")

# cmdscale(d, k = 2, eig = FALSE, add = FALSE, x.ret = FALSE)
# as.dist(m, diag = FALSE, upper = FALSE)
# dissimMatrix <- matrix with lower triangle = dissimilarities

ji <- inp1$lqi > 128
inp1$lqi[ji] = 383 - inp1$lqi[ji]
inp1$lqi[!ji] = 128 - inp1$lqi[!ji]

mat <- array(0, dim=c(19,19))
matb <- array(0, dim=c(19,19))
mat2 <- array(0, dim=c(19,19))

lqis <- numeric()
errors <- array(0,dim=c(19,20))

len = 10000 #length(inp1$src)

for (i in 2:19) {
  for (j in (i+1):20) {
      x <- 0
      for (k in 1:len) {
        if ((inp1$src[k] == i && inp1$pongsrc[k] == j) || ( inp1$src[k] == j && inp1$pongsrc[k] == i)) {
          lqis[x] <- inp1$lqi[k]
          x<-x+1
        }
      }
#        print(lqis)
      mat[j-1,i-1] <- (-10.50084 + (mean(lqis) * 0.09973)) #to get dissimilarities
      mat[i-1,j-1] <- mat[j-1,i-1]
      matb[j-1,i-1] <- (-11.04994 + (mean(lqis) * 0.10467)) #to get dissimilarities
      matb[i-1,j-1] <- matb[j-1,i-1]

      mat2[i-1,j-1] <- distance(i,j)
      mat2[j-1,i-1] <- mat2[i-1,j-1]
  }
 }

print(mat)



for (i in 2:20) {
  x <-1
  for (j in 2:20) {
     if ( i != j ) {
       errors[i-1,x] <-  sqrt((mat2[i-1,j-1] - mat[i-1,j-1])^2)
       x <- x+1
     }
  }

}


errorsVars <- numeric()
errorsMeans <- numeric()

for (l in 2:20) {
    errorsMeans[l] <- mean(errors[l-1,])
   errorsVars[l] <- var(errors[l-1,])
}

x11()
layout(matrix(1:2, 2, 1))

barplot(errorsMeans,main ="nodes distance estimation error mean",col = hsv((1:19)/20,.5,.5))
#text(seq(2,24,by=1.19),0.1,labels=2:20,col="white")

barplot(errorsVars,main = "nodes distance estimation error var",col = hsv((1:19)/20,.5,.5))
#text(seq(2,24,by=1.19),0.1,labels=2:20,col="white")


