plotRSSIps <- function(nodeid=2) {
	oldwd = getwd()
	setwd("C:\\Documents and Settings\\dwarfy\\My Documents\\MLG\\memoiremlg\\LOCALISATION\\EXPEBIBLIO")

	inp1 <- scan("N1.txt", list(0,0,0,0,0,0,0),dec = ",")
	rssi1 <- inp1[[7]]
	fromid1 <- inp1[[4]]
	toid1 <- inp1[[5]]
	time1 <- inp1[[1]]

	inp2 <- scan("N2.txt", list(0,0,0,0,0,0,0),dec = ",")
	rssi2 <- inp2[[7]]
	fromid2 <- inp2[[4]]
	toid2 <- inp2[[5]]
	time2 <- inp2[[1]]
	
	setwd(oldwd)

	rssi = c(rssi1,rssi2)
	fromid = c(fromid1,fromid2)
	toid = c(toid1,toid2)
	times = c(time1,time2)

	x <- 0
	len <- length(times)
	rssiX <- numeric()
	timesX <- numeric()

	startime <- 0.0

	times <- times / (3600 * 1024)

	for (j in 1:20) {
		x <- 0
		for (i in 1:len) {
			if (i != j) {
				if (fromid[i] == nodeid && toid[i] == j ) {
					if (x == 0) {
						startime = times[i]
					}
					rssiX[x] <- rssi[i]
					timesX[x] <- times[i] - startime
					x<-x+1
				}
			}
		}
		
		filename <- paste("rssinode",nodeid,"to",j,".ps",sep="") 
		postscript(filename, family = "NimbusSan")

		maintitle <- paste("rssi node",nodeid,"to",j)
		subtitle <- paste("RSSI mean :",mean(rssiX),"| RSSI var :",var(rssiX))
		plot(timesX,rssiX,main=maintitle,sub=subtitle,xlab="Time from start of experience (hours)",ylab="RSSI value",pch=20)
		
		dev.off()

	}

	
}

plotRSSIps(18)