#localiseMDSRssi.r

mat <- array(0, dim=c(19,19))

diag(mat) <- 0

rssis <- numeric()

len = 10000 #length(inp1$src)

for (i in 2:19) {
  for (j in (i+1):20) {
      x <- 0
      for (k in 1:len) {
        if ((inp1$src[k] == i && inp1$pongsrc[k] == j) || ( inp1$src[k] == j && inp1$pongsrc[k] == i)) {
          rssis[x] <- inp1$rssi[k]
          x<-x+1
        }
      }
      mat[j-1,i-1] <- mean(rssis)
  }


}

mds <- cmdscale(as.dist(mat),add=TRUE,eig=TRUE,k=18)
print("Eigen values MDS RSSI")
print(mds$eig)

x <- mds$points[,1]
y <- -mds$points[,2]

xy <- cbind(x,y)
xoyo <-cbind(real.x,real.y)

good <- procrustes(xoyo, xy)

mse <-  sqrt(good$ss/19)

plotab <- good$Yrot

x11()
plot(good,main='MDS localisation with RSSI',sub=paste('position MSE = ',mse))
browser()


