#plotDistRssiLqiReg.r

  # cmdscale(d, k = 2, eig = FALSE, add = FALSE, x.ret = FALSE)
  # as.dist(m, diag = FALSE, upper = FALSE)
  # dissimMatrix <- matrix with lower triangle = dissimilarities

 	ji <- inp1$lqi > 128
	inp1$lqi[ji] = 383 - inp1$lqi[ji]
	inp1$lqi[!ji] = 128 - inp1$lqi[!ji]

  lqis <- numeric()
  lqiX <- numeric()
  distX <- numeric()


  len = 10000 #length(inp1$src)

  y <- 0

  for (i in 2:19) {
    for (j in (i+1):20) {
        x <- 0
        for (k in 1:len) {
          if ((inp1$src[k] == i && inp1$pongsrc[k] == j) || ( inp1$src[k] == j && inp1$pongsrc[k] == i)) {
            lqis[x] <- inp1$lqi[k]
            x<-x+1
          }
        }
        lqiX[y] <- mean(lqis)
        distX[y] <- distance(i,j)
        y <- y+1
    }


  }
  lin <- lm(distX ~ lqiX)

	maintitle <- paste("Distance / mean LQI")
  plot(lqiX,distX,main=maintitle,ylab="Distance Between nodes",xlab="LQI value",pch=3, col = "dark red")

  mytext1 <- paste("LQI mean :",mean(lqiX),"LQI var :",var(lqiX),"#mesures :",length(distX))
  mytext2 <- paste("#nodes : 19","regline intercept :",lin$coefficients[1],"regline lqiX :",lin$coefficients[2])

  mtext(mytext1, side = 1,line=2)
  mtext(mytext2, side = 1,line=4)

  summary(lin)
  print (lin)

	abline( coef = lin$coefficients )
