plotDistLQI <- function() {
	oldwd = getwd()
	setwd("C:\\Documents and Settings\\dwarfy\\My Documents\\MLG\\memoiremlg\\LOCALISATION\\EXPEBIBLIO")

	inp1 <- scan("N1.txt", list(0,0,0,0,0,0,0),dec = ",")
	#rssi1 <-inp1[[7]]
	lqi1 <- inp1[[6]]
	fromid1 <- inp1[[4]]
	toid1 <- inp1[[5]]
	

	
	inp2 <- scan("N2.txt", list(0,0,0,0,0,0,0),dec = ",")
	#rssi2 <- inp2[[7]]
	lqi2 <- inp2[[6]]
	fromid2 <- inp2[[4]]
	toid2 <- inp2[[5]]
	
	
	setwd(oldwd)

	lqi = c(lqi1,lqi2)
	#rssi = c(rssi1,rssi2)
	fromid = c(fromid1,fromid2)
	toid = c(toid1,toid2)
	#times = c(time1,time2)

	x <- 0
	len <- length(fromid)
	lqiX <- numeric()
	distX <- numeric()
	

	startime <- 0.0

	#times <- times / (3600 * 1024)

	x <- 0

	len <-200

	for (i in 1:len) {
		if (fromid[i] > 1 && toid[i] > 1) {
			lqiX[x] <- lqi[i]
			distX[x] <- distance(fromid[i],toid[i])
			x<-x+1		
		}
		
	}

	filename <- "distance-lqi.ps" 
	postscript(filename, family = "NimbusSan")

	maintitle <- paste("Distance / LQI")	
	subtitle <- paste("LQI mean :",mean(lqiX),"| LQI var :",var(lqiX),"| #mesures :",len,"| #nodes :19" )
	plot(lqiX,distX,main=maintitle,sub=subtitle,ylab="Distance Between nodes",xlab="LQI value",pch=3, xlim=c(210,260) , col = "dark red")
	

	dev.off()



	
}



#	NETWORK TOPOLOGY

# 	5	9	13	17		
#
# 	4	8	12	16	20	< 
#						| vdist
# 	3	7	11	15	19	<
#
# 	2	6	10	14	18
#	<-hdist->

#right now we'll say hdist = 1
#and vdist = 1
#But this could measured in the biblio


#	col	
#	0  1 2  3  4
	
#lig 3	3 7 11 15 
#    2	2 6 10 14 18
#    1	1 5 9  13 17
#    0	0 4 8  12 16


#ddist <- sqrt((hdist ^ 2)+(vdist ^ 2))


#returns the distance between 2 nodes (oracle)
distance <- function(AnodeId,BnodeId) {
hdist <- 1.5
vdist <- 1

	
	if (AnodeId == BnodeId  ) {
		return(0)
	}
	
	#to begin at 0
	A <- AnodeId - 2
	B <- BnodeId - 2
	
	dist <- 0
	

	if (A > B) {
		tmp = B;
		B = A;
		A = tmp;
	} #now A is everytime the node with smaller nodeId   
	
	Acol <- A %/% 4 
	Alig <- A %% 4
	Bcol <- B %/% 4 
	Blig <- B %% 4
	
	if (Acol == Bcol) {
		return ((Blig - Alig) * vdist)
	}
	
	if (Alig == Blig) {
		return ((Bcol - Acol) * hdist)
	}
	
	
	#if we arrive here both nodes are neithwarningser same lig neither same col

	if (Alig < Blig) { 
		return (sqrt((((Bcol - Acol)*hdist)^2) + (((Blig - Alig)*vdist)^2)) )
	}
	else { 
		return (sqrt((((Bcol - Acol)*hdist)^2) + (((Alig - Blig)*vdist)^2)) )
	}
}
