/*
 * Localisator.java
 *
 * Created on 8 mars 2007, 16:55
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package net.tinyos.mapviewer;

import Jama.*;


/**
 *
 * @author dwarfy
 */

//should have infos about anchors node.

public class Localisator {
    private Matrix A,b,s;
    private Estimator E;
    
    private float[][] nodesPos;
        
    /** Creates a new instance of Localisator */
    public Localisator() {
        nodesPos = new float[Config.NUM_NODES][3];
    }
    
    //we suppose Est is a fully functionnal estimator
    public void setEstimator(Estimator Est) {
        E = Est;
    }
    
    public void localiseLat() {
        
        //here an arrayIndexOutOfBoundsException is thrown
        //try {
            for (int i=0;i<Config.NUM_NODES;i++) {
                A = new Matrix(Config.NUM_ANCHORS-1,2);
                b = new Matrix(Config.NUM_ANCHORS-1,1);
                s = new Matrix(2,2);

                float[] distAnchorsNode = E.getDistances(i);
                    System.out.println("Distance Anchors - nodes");
                    
                for (int x=0;x<distAnchorsNode.length;x++) {
                    System.out.println(distAnchorsNode[x]);
                }
                
                
                for (int j=0;j<Config.NUM_ANCHORS-1;j++) {
                    A.set(j,0,2 * (Config.ANCHORS_POS[j][0] - Config.ANCHORS_POS[Config.NUM_ANCHORS-1][0]));
                    
                    
                    A.set(j,1,2 * (Config.ANCHORS_POS[j][1] - Config.ANCHORS_POS[Config.NUM_ANCHORS-1][1]));
                    
                    
                    b.set(j,0,Math.pow(Config.ANCHORS_POS[j][0],2) - Math.pow(Config.ANCHORS_POS[Config.NUM_ANCHORS-1][0],2)
                    + Math.pow(Config.ANCHORS_POS[j][1],2) - Math.pow(Config.ANCHORS_POS[Config.NUM_ANCHORS-1][1],2)
                    + Math.pow(distAnchorsNode[Config.NUM_ANCHORS-1],2) - Math.pow(distAnchorsNode[j],2) );

                }
                    A.print(1,1);
                    b.print(1,1);
                    
                    
                    s = A.solve(b);
                    
                    s.print(1,1);
                    

                    nodesPos[i][0]= (float)s.get(0,0);
                    nodesPos[i][1]= (float)s.get(1,0);                    
                    
                System.out.println(nodesPos[i][0]);
                System.out.println(nodesPos[i][1]);

            }
        /*} catch (Exception e)     {
            System.out.println("LocaliseLat failed, array exception");
        }*/
    }

    public float[][] getNodesPos() {
        return nodesPos;
    }

}
